;
; d64.asm - D64 writer plugin for IDE64 filemanager
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

p1		= $fb

tbl1		= $2600
tbl2		= $1900
tbl3		= $1a00
tbl4		= $1b00
e1		= $1c00
e2		= $1d00
e3		= $1e00
e4		= $1f00
e5		= $2000
e6		= $2100
e7		= $2200
e8		= $2300
tabl1		= $2400
tabl2		= $2500
loadp		= $2700

inter		= 3
inter2		= 16

		.include "contact.inc"

start		sta ty+1
		stx ged+1
		sty ged+2
		jsr $ffbd
		lda #4
		ldx $ba
		tay
		jsr $ffba
                jsr $ffe7
		jsr $ffc0
                ldx #4
                jsr $ffc6
                jsr $ffcf
                lda $90
                pha
                jsr $ffcc
                lda #4
                jsr $ffc3
                pla
                ora $90
                beq kwen
                lda #<txt6
                ldy #>txt6
                jsr $ab1e
                lda #0
                sta 198
                jsr $ffe4
                beq *-3
                rts
kwen
		sta $d07a		;scpu 1mhz
		sei
		lda #48
		cmp $d012
		bne *-3
		bit $d011
		bmi pal
		cmp $d012
		beq *-3
		cmp $d012
		bne *-3
		bit $d011
		bmi pal
		lda #$29
		sta drive+ntsc1-rutin
		sta drive+ntsc2-rutin
		sta drive+ntsc3-rutin
		sta drive+ntsc4-rutin
		sta drive+ntsc5-rutin
		lda #$a5
		sta ntsc6
		sta ntsc7
		sta ntsc8
		sta ntsc9
		sta ntsca
		sta ntscb
		sta ntscc
		sta ntscd
		sta ntsce
		sta ntscf
pal
		lda $d020
		sta d020+1
		lda $d021
		sta d021+1
                lda $d018
                sta d018+1
                lda 646
                sta o646+1
                lda 657
                sta o657+1
                lda $03
                sta o3+1
		cli
		lda #6
		sta $d020
		sta $d021
rest		lda #<text
		ldy #>text
		jsr $ab1e
		ldy #0
ged		lda $ffff,y
		jsr $ffd2
		iny
ty		cpy #0
		bne ged
		lda #<txt2
		ldy #>txt2
		jsr $ab1e

		ldx #0
                stx $9d
		stx 198
		stx $cc
                jsr $ffe4
		beq *-3
                inc $cc
                ldx #0
                stx $cf
		ldx #8
		cmp #"8"
		beq yb
		inx
		cmp #"9"
		beq yb
		inx
		cmp #"0"
		beq yb
		inx
		cmp #"1"
		beq yb
                cmp #"D"
                bne *+5
                jmp dirlist
		ldx #0
		lda #"N"
yb		stx bww+1
		jsr $ffd2
		ldx bww+1
		bne *+5
fse		jmp vege

		lda #<copy40txt
		ldy #>copy40txt
		jsr yesno
                beq fse
                ldx #36
                bcc *+4
                ldx #41
                stx tr401+1
                stx drive+tr402+1-rutin
                dex
                stx drive2+tr403+1-rutin2

		lda #<formattxt
		ldy #>formattxt
		jsr yesno
                beq fse
                ldx #0
                bcc *+4
                ldx #1
                stx fr+1
                bcc sued

		lda #<diskidtxt
		ldy #>diskidtxt
		jsr yesno
                beq fse
                bcc sued
                lda #13
                jsr $ffd2
                jsr loaddir
                lda loadp+$a2
                sta drive2+idat1+1-rutin2
                lda loadp+$a3
                sta drive2+idat2+1-rutin2
                lda #$85
                sta drive2+idat1+2-rutin2
                sta drive2+idat2+2-rutin2

sued		jsr $ffc0

fr		ldx #1
                beq fk
		jsr inst
                bcs kne

                ldx #0
fk		jsr inst
                bcc el
kne		lda #4
		jsr $ffc3
		jmp vege

el		lda #3
		sta $dd00
		sta $03

		ldy #0			;generate transfer tables
fdf		tya
		and #%00001010
		lsr a
		tax
		lda ccc,x
		sta tbl1,y
		tya
		and #%00000101
		tax
		lda ccc,x
		sta tbl2,y
		tya
		lsr a
		lsr a
		lsr a
		lsr a
		pha
		and #%00001010
		lsr a
		tax
		lda ccc,x
		sta tbl3,y
		pla
		and #%00000101
		tax
		lda ccc,x
		sta tbl4,y
		iny
		bne fdf

lkl		tya			;generate gcr conversion tables
		lsr a
		lsr a
		lsr a
		lsr a
		tax
		lda gcr,x
		sta g1
		tya
		and #15
		tax
		lda gcr,x
		sta g2

		lda g1
		asl a
		asl a
		asl a
		sta te1+1		;11111222
		lda g2
		lsr a
		lsr a
te1		ora #0
		sta e1,y

		lda g2
		lsr a
		ror a
		ror a
		and #%11000000
		sta e2,y		;22000000

		lda g2
		cmp #%00010000
		lda g1
		rol a
		sta e3,y		;00111112

		lda g2
		asl a
		asl a
		asl a
		asl a
		sta e4,y		;22220000

		lda g1
		lsr a
		sta e5,y		;00001111

		ror a
		ror a
		ror a
		and #%00100000
		ora g2
		asl a
		asl a
		sta e6,y		;12222200

		lda g1
		lsr a
		lsr a
		lsr a
		sta e7,y		;00000011

		lda g1
		asl a
		asl a
		asl a
		asl a
		asl a
		ora g2
		sta e8,y		;11122222

		iny
		bne lkl
                
		lda #11
		sta $d011
		lda #54
		sta $01
ujsav
		dec pben
                bne fd

		lda #5
		sta pben
                lda #>loadp
                sta strt+1
                sta p1+1
		ldx #4
		jsr $ffc6
		ldx tr+innen-$0300
		lda hsz-1+innen-$0300,x
		clc
		adc hsz+innen-$0300,x
		adc hsz+1+innen-$0300,x
		adc hsz+2+innen-$0300,x
		adc hsz+3+innen-$0300,x
		tay
		ldx #0
		lda #1
		sta p1
		lda #p1
		jsr $def4
                sei

fd		lda sc+innen-$0300
		clc
strt		adc #>loadp
		sta be15+2
		sta be16+2
		sta be17+2
		sta be18+2
		sta be12+2
		sta be13+2
		sta be14+2

		ldy #0
		tya
be14		eor loadp+1,y
		iny
		bne be14
		sta g1

		ldx #7			;datablock identifyer
		bne *+5
be15		ldx loadp,y
		lda e1,x
		sta tabl2,y
		lda e2,x
be16		ldx loadp+1,y
		ora e3,x
		sta tabl1,y
		iny
		lda e4,x
be17		ldx loadp+1,y
		ora e5,x
		sta tabl1,y
		iny
		lda e6,x
be18		ldx loadp+1,y
		ora e7,x
		sta tabl1,y
		iny
		lda e8,x
		sta tabl1,y
		iny
		bne be15

vv		lda $dd00
		and #192
		cmp #64
		bne vv

		ldy #3
		lda #3+16
		sta $dd00
                .page
myx		bit $dd00
		bpl myx
                .endp

		sty $dd00
		ldy #0

		cmp (0,x)
		ldx e1+7
                .page
		bne be+3

pben		.byte 1

be		ldx tabl2,y		;a
		lda #16+3
		.endp
		sta $dd00
		lda tbl3,x
		sta $dd00
		lda tbl4,x
		sta $dd00
		lda tbl1,x
		sta $dd00
		lda tbl2,x
		sta $dd00
ntsc6		lda #3
		nop
		sta $dd00

		ldx tabl1,y
		nop
		lda #16+3
		sta $dd00
		lda tbl3,x
		sta $dd00
		lda tbl4,x
		sta $dd00
		lda tbl1,x
		sta $dd00
		lda tbl2,x
		sta $dd00
ntsc7		lda #3
		iny
		sta $dd00

		ldx tabl1,y
		nop
		lda #16+3
		sta $dd00
		lda tbl3,x
		sta $dd00
		lda tbl4,x
		sta $dd00
		lda tbl1,x
		sta $dd00
		lda tbl2,x
		sta $dd00
ntsc8		lda #3
		iny
		sta $dd00

		ldx tabl1,y
		nop
		lda #16+3
		sta $dd00
		lda tbl3,x
		sta $dd00
		lda tbl4,x
		sta $dd00
		lda tbl1,x
		sta $dd00
		lda tbl2,x
		sta $dd00
ntsc9		lda #3
		iny
		sta $dd00

		ldx tabl1,y
		nop
		lda #16+3
		sta $dd00
		lda tbl3,x
		sta $dd00
		lda tbl4,x
		sta $dd00
		lda tbl1,x
		sta $dd00
		lda tbl2,x
		sta $dd00
ntsca		lda #3
		iny
		sta $dd00

		beq *+5
		jmp be

		iny

be12		ldx loadp+255,y			;last data byte
		lda e1,x
		tax
		lda #16+3
		sta $dd00
		lda tbl3,x
		sta $dd00
		lda tbl4,x
		sta $dd00
		lda tbl1,x
		sta $dd00
		lda tbl2,x
		sta $dd00
ntscb		lda #3
		nop
		sta $dd00

be13		ldx loadp+255,y			;last data byte
		lda e2,x
		ldx g1                          ;checksumm
		ora e3,x
		tax
		lda #16+3
		sta $dd00
		lda tbl3,x
		sta $dd00
		lda tbl4,x
		sta $dd00
		lda tbl1,x
		sta $dd00
		lda tbl2,x
		sta $dd00
ntscc		lda #3
		nop
		sta $dd00

		ldx g1                          ;checksumm
		lda e4,x
		ora #%00000101			;0
		tax
		lda #16+3
		sta $dd00
		lda tbl3,x
		sta $dd00
		lda tbl4,x
		sta $dd00
		lda tbl1,x
		sta $dd00
		lda tbl2,x
		sta $dd00
ntscd		lda #3
		nop
		sta $dd00

		cmp (0,x)
		lda #16+3
		sta $dd00
		lda tbl3+%00101001		;0
		sta $dd00
		lda tbl4+%00101001
		sta $dd00
		lda tbl1+%00101001
		sta $dd00
		lda tbl2+%00101001
		sta $dd00
ntsce		lda #3
		nop
		sta $dd00

		cmp (0,x)
		lda #16+3
		sta $dd00
		lda tbl3+%01001010		;0
		sta $dd00
		lda tbl4+%01001010
		sta $dd00
		lda tbl1+%01001010
		sta $dd00
		lda tbl2+%01001010
		sta $dd00
ntscf		lda #3
		nop
		sta $dd00

		dec db+innen-$0300
		beq fdx

		ldy tr+innen-$0300
		lda sc+innen-$0300
		clc
		adc #inter
fhhs		cmp hsz-1+innen-$0300,y
		bcc dws
		sbc hsz-1+innen-$0300,y
dws		tax
		inc foglalt+innen-$0300,x
		beq fnv
		inx
		txa
		jmp fhhs
fnv
		stx sc+innen-$0300
		jmp fd

fdx
		lda #$ff
		ldx #20
fnxs		sta foglalt+innen-$0300,x
		dex
		bpl fnxs

		inc tr+innen-$0300
		ldy tr+innen-$0300
		lda hsz-1+innen-$0300,y
		sta db+innen-$0300     
		lda sc+innen-$0300
		clc
		adc #inter2
		cmp hsz-1+innen-$0300,y
		bcc tk2
		sbc hsz-1+innen-$0300,y
tk2		sta sc+innen-$0300
		tax
		inc foglalt+innen-$0300,x
tr401		cpy #36
		beq kec
                lda strt+1
                clc
                adc hsz-2+innen-$0300,y
                sta strt+1
		jmp ujsav
kec
		lda #27
		sta $d011
		lda #55
		sta $01

		lda #4
		jsr $ffc3
		jsr $ffe7
vege		jsr $e544
d020		lda #0
		sta $d020
d021		lda #0
		sta $d021
d018		lda #0
                sta $d018
o646		lda #0
                sta 646
o657		lda #0
                sta 657
o3		lda #0
                sta $03
		sta $d07b		;scpu
		rts

nr		.byte <drive,<drive2
		.byte >drive,>drive2
                .byte <rutin,<rutin2
                .byte >rutin,>rutin2
                .byte <go,<go2
                .byte >go,>go2
                .byte <rutinend,<rutinend2
                .byte >rutinend,>rutinend2

inst		lda nr,x
		sta p1
		lda nr+2,x
		sta p1+1
		lda nr+4,x
		sta $fd
		lda nr+6,x
		sta $fe
                stx gat1+1
                stx gat2+1

		lda #15
bww		ldx #8
		tay
		jsr $ffba
		lda #0
		jsr $ffbd
		jsr $ffc0

dt		ldx #15
		jsr $ffc9
		lda $9a
		cmp #3
		bne okk
                sec
                rts

okk		lda #"M"
		jsr $eddd
		lda #"-"
		jsr $eddd
		lda #"W"
		jsr $eddd
		lda $fd
		jsr $eddd
		lda $fe
		jsr $eddd
		lda #34
		jsr $eddd
		ldy #0
fg		lda (p1),y
		jsr $eddd
		iny
		cpy #34
		bne fg
		jsr $ffcc
		lda p1
		clc
		adc #34
		sta p1
		bcc *+4
		inc p1+1
		lda $fd
		clc
		adc #34
		sta $fd
		bcc *+4
		inc $fe
gat2            ldx #0
		lda $fd
                cmp nr+12,x
		lda $fe
                sbc nr+14,x
		bcc dt

		ldx #15
		jsr $ffc9
		lda #"M"
		jsr $eddd
		lda #"-"
		jsr $eddd
		lda #"E"
		jsr $eddd
gat1            ldx #0
                lda nr+8,x
		jsr $eddd
                lda nr+10,x
		jsr $eddd
		jsr $ffcc
                clc
                rts

yesno           jsr $ab1e
		dec $cc
                jsr $ffe4
                beq *-3
                inc $cc
                ldx #0
                stx $cf
                cmp #3
                beq fsee
                cmp #"Y"
                beq *+4
                lda #"N"
                jsr $ffd2
                cmp #"O"
fsee		rts

ccc		.byte %00000011
		.byte %00100011
		.byte %00000000
		.byte %00000000
		.byte %00010011
		.byte %00110011

gcr		.byte $0a,$0b,$12,$13
		.byte $0e,$0f,$16,$17
		.byte $09,$19,$1a,$1b
		.byte $0d,$1d,$1e,$15

g1		.byte 0
g2		.byte 0

innen
drive
		.logical $300

rutin
;---------------------------------------
irq		jmp hd3

up		.byte $00,$10,$20,$30
		.byte $40,$50,$60,$70
		.byte $80,$90,$a0,$b0
		.byte $c0,$d0,$e0,$f0

hd3		lda tr
		sta $18
		sta $06
		lda sc
		sta $19
		sta $07

		jsr sendblock

		lda $4a
		beq err
		jsr $fa63		;stepper
                
err		lda tr
		sta $22
                ldx #4
wef             cmp ts-1,x
                dex
                bcs wef
		lda $fed1,x
		sta $43
		lda $1c00
		and #$9f
		ora sptab,x
		sta $1c00		;density
		lda #$ee
		sta $1c0c

		jsr $f510		;search sector

		lda $1c00
		ora #$08
		sta $1c00		;led on

		ldx #9
gr		bvc gr
		clv
		dex
		bne gr			;skip 9 bytes
		lda #255
		sta $1c03		;output
		lda $1c0c
		and #$1f
		ora #$c0
		sta $1c0c		;pcr output
		lda #$ff
		ldx #5
		sta $1c01
		clv
gr2		bvc gr2
		clv
		dex
		bne gr2			;5 write $ff bytes (sync)
		ldy #64
ge		lda $0600,y
		bvc *
		clv
		sta $1c01
		lda $0641,y
		bvc *
		clv
		sta $1c01
		lda $0682,y
		bvc *
		clv
		sta $1c01
		lda $06c3,y
		bvc *
		clv
		sta $1c01
		lda $0704,y
		bvc *
		clv
		sta $1c01
		dey
		bpl ge
		bvc *
		jsr $fe00		;switch to read

		lda $1c00
		and #255-$08
		sta $1c00		;led off

		dec db
		beq fux

		ldy tr
		lda sc
		clc
		adc #inter
fhh		cmp hsz-1,y
		bcc dw
		sbc hsz-1,y
dw		tax
		inc foglalt,x
		beq fn
		inx
		txa
		jmp fhh

fn		stx sc
		jmp irq

fux		ldx #20
		lda #$ff
fnx		sta foglalt,x
		dex
		bpl fnx
		inc tr
		ldy tr
		lda hsz-1,y
		sta db
		lda sc
		clc
		adc #inter2
		cmp hsz-1,y
		bcc tk
		sbc hsz-1,y
tk		sta sc
		tax
		inc foglalt,x
tr402		cpy #36
		bcs gw
		jsr $fa65
                lda #1
                sta $4a
                jmp irq

gw      	lda #$00
		jmp $f969
;---------------------------------------
ts		.byte 255,31,25,18
sptab		.byte $00,$20,$40,$60
;---------------------------------------
tr		.byte 1
sc		.byte 0
db		.byte 21

foglalt		.byte $00,$ff,$ff,$ff
		.byte $ff,$ff,$ff,$ff
		.byte $ff,$ff,$ff,$ff
		.byte $ff,$ff,$ff,$ff
		.byte $ff,$ff,$ff,$ff
		.byte $ff

hsz		.byte 21,21,21,21
		.byte 21,21,21,21
		.byte 21,21,21,21
		.byte 21,21,21,21
		.byte 21
		.byte 19,19,19,19
		.byte 19,19,19
		.byte 18,18,18,18
		.byte 18,18
		.byte 17,17,17,17,17
                .byte 17,17,17,17,17

sendblock
		lda $1800
		and #%11110000
		sta df+1
		sta df2+1
		sta df3+1
		sta df4+1
		sta df5+1
		ora #%00000011
		tax
		stx bt+1
		stx bt2+1
		stx bt3+1
		stx bt4+1
		stx bt5+1
		lda #2
		sta $1800
                .page
		cpx $1800
		bcs *-3
                .endp
		lda #0
		sta $1800
		ldy #64
                .page
		cpx $1800
		bcc *-3
                .endp

fy		.page
		cpx $1800
		bcs *-3
                .endp
ntsc1		bit $ea

		lda $1800
		asl a
		nop
		ora $1800
		and #15
		tax
		lda $1800
		asl a
df		eor #0
		eor $1800
		ora up,x
		sta $0600,y
bt		ldx #0
		.page
		cpx $1800
		bcs *-3
                .endp
ntsc2		bit $ea

		lda $1800
		asl a
		nop
		ora $1800
		and #15
		tax
		lda $1800
		asl a
df2		eor #0
		eor $1800
		ora up,x
		sta $0641,y
bt2		ldx #0
		.page
		cpx $1800
		bcs *-3
                .endp
ntsc3		bit $ea

		lda $1800
		asl a
		nop
		ora $1800
		and #15
		tax
		lda $1800
		asl a
df3		eor #0
		eor $1800
		ora up,x
		sta $0682,y
bt3		ldx #0
		.page
		cpx $1800
		bcs *-3
                .endp
ntsc4		bit $ea

		lda $1800
		asl a
		nop
		ora $1800
		and #15
		tax
		lda $1800
		asl a
df4		eor #0
		eor $1800
		ora up,x
		sta $06c3,y
bt4		ldx #0
		.page
		cpx $1800
		bcs *-3
                .endp
ntsc5		bit $ea

		lda $1800
		asl a
		nop
		ora $1800
		and #15
		tax
		lda $1800
		asl a
df5		eor #0
		eor $1800
		ora up,x
		sta $0704,y
bt5		ldx #0

		dey
                .page
		bmi *+5
		jmp fy
                .endp

		ldx #8
		stx $1800
		rts

go		cld
		lda #8
		sta $1800
		lda #20			;stepper speed
		sta $1c05
		jsr $d005		;initialize
		ldx #0
		stx $07
		inx
		stx $06
		lda #$b0		;seek
		sta $00
		lda $00
		bmi *-2
dx		lda #$e0		;start
		sta $00
		lda $00
		bmi *-2
		bne dx
		jmp $d005		;initialize

rutinend
		.here

readtxt		.text "D",13,13,"D"+128,"IRECTORY LISTING:",13,0
dirtxt		.text 13,145,"0 ",$12,$9b,0
blocktxt	.text " BLOCKS FREE.",13,0

loaddir		lda #1
		bne *+3
                rts
                dec loaddir+1

		jsr $ffc0

		ldx #4
		jsr $ffc6
		lda #<loadp
		sta p1
                lda #>loadp
                sta p1+1
                ldx #0
                ldy #21*5
                lda #p1
                jsr $def4
                lda #"."
                jsr $ffd2
                ldx #0
                ldy #21*6
                lda #p1
                jsr $def4
                lda #"."
                jsr $ffd2
                ldx #0
                ldy #21*6
                lda #p1
                jsr $def4
                lda #"."
                jsr $ffd2
                ldx #0
                ldy #18
                lda #p1
                jsr $def4
                
                jsr $ffcc
                lda #4
                jmp $ffc3

dirlist		
		lda #<readtxt
                ldy #>readtxt
                jsr $ab1e

		jsr loaddir

		lda #<dirtxt
                ldy #>dirtxt
                jsr $ab1e
                lda #34
                jsr $ffd2
                ldy #0
sk              lda loadp+$90,y
                jsr $ffd2
                iny
                cpy #16
                bne sk
                lda #34
                jsr $ffd2
                lda #32
                jsr $ffd2
                iny
sk2             iny
		lda loadp+$90,y
                jsr $ffd2
                cpy #22
                bne sk2
                lda #13
                jsr $ffd2
                
                lda #<(loadp+$100)
                sta p1
                lda #>(loadp+$100)
dloop2           sta p1+1
                
dloop           ldy #2
		lda (p1),y
                and #%10001111
                beq nf
                
                ldy #30
                lda (p1),y
                tax
                iny
                lda (p1),y
                jsr $bdcd

                sec
                jsr $fff0
                ldy #5
                clc
                jsr $fff0
                
                lda #34
                jsr $ffd2
                ldy #5
ke              lda (p1),y
                iny
                cmp #$a0
                beq se
                jsr $ffd2
                cpy #21
                bne ke
se		lda #34
sir		jsr $ffd2
                cpy #21
                beq gec
                lda (p1),y
                iny
                bne sir
gec
                sec
                jsr $fff0
                ldy #23
                clc
                jsr $fff0

                ldy #2
                lda (p1),y
                asl
                pha
                lda #"*"
                bcc *+4
                lda #" "
                jsr $ffd2
                
                lda (p1),y
                and #15
                cmp #5
                bcc *+4
                lda #5
                tay
                lda ft1,y
                jsr $ffd2
                lda ft2,y
                jsr $ffd2
                lda ft3,y
                jsr $ffd2
                
                pla
                asl
                lda #"<"
                bcs *+4
                lda #" "
                jsr $ffd2
                lda #13
                jsr $ffd2
                
nf		jsr $ffe4
		cmp #3
                beq stop
		lda p1
		clc
                adc #32
                sta p1
                bcs *+5
                jmp dloop

                ldy #0
                lda (p1),y
                cmp #18
                bne wer
                iny
                lda (p1),y
                cmp #19
                bcs wer
                adc #>loadp
                jmp dloop2
wer
		lda #0
                sta bh+1
		ldy #$8c
sue             cpy #18*4
		beq cds
		clc
                adc loadp,y
                bcc *+5
                inc bh+1
cds             dey
                dey
                dey
                dey
                bne sue
		
                tax
bh              lda #0
                jsr $bdcd
		lda #<blocktxt
                ldy #>blocktxt
                jsr $ab1e
                
stop            lda #0
                sta 198
                lda 198
                beq *-2
                jmp rest

ft1		.text "DSPUR?"
ft2		.text "EERSE?"
ft3             .text "LQGRL?"
                
drive2		
		.logical $400
rutin2
		lda $8
                ldx #4
wef2            cmp ts2-1,x
                dex
                bcs wef2
		lda $fed1,x
                sta $43
                lda $1c00
                and #$9f
                ora sptab2,x
                eor #8
                sta $1c00
                lda $51
                bmi see
                ldy #0
                cmp ($32),y
                beq fwe
                sta ($32),y
                jmp $f99c
fwe		lda #$14
		sta $620
		jmp $fb0c
see             jmp $facb
go2             
idat1   	lda #0
                bit $12
idat2           lda #0
                bit $13
                lda #0
                .byte $2c
c2              lda $08
tr403           cmp #40
                bcs c3
                adc #1
                sta $08
                cmp #1
                beq *+4
                sta $51
                lda #$e0
                sta $01
                lda $01
                bmi *-2
                cmp #2
                bcc c2
c3              lda $1c00
		and #255-8
                sta $1c00
		rts
ts2		.byte 255,31,25,18
sptab2		.byte $00,$20,$40,$60

rutinend2
                .here

text		.text 9,14,5,147
		.text "I"+128,"D"+128,"64 WRITER PLUGIN"
		.text " V0.3B",13
		.text "(","C"+128,") 2000-2003 BY ","S"+128,"OCI/"
		.text "S"+128,"INGULAR",13
		.text 158,"U"+128,"SE THIS AT YOUR OWN"
		.text " RISK!",13,13
                .text 155,"P"+128,"RESS 8/9/0/1 FOR DRIVE, D FOR DIRECTORY",13
		.text "C"+128,"OPY ",5,0
txt2		.text 155," TO DRIVE [",164,"]",157,157,0
copy40txt      	.text 13,155,"C"+128,"OPY 40 TRACKS?",5,0
formattxt	.text 13,155,"F"+128,"ORMAT?",5,0
diskidtxt	.text 13,155,"D"+128,"ISK ID FROM IMAGE?",5,0
txt6		.text 13,"UNABLE TO OPEN "
		.text "FILE.",13,0
